#---
# Excerpted from "Crafting Rails Applications",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material,
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose.
# Visit http://www.pragmaticprogrammer.com/titles/jvrails for more book information.
#---
require 'test_helper'

class NavigationTest < ActiveSupport::IntegrationCase
  test '.merb template handler' do
    visit '/handlers/merb'
    expected = '<p>MERB template handler is <strong>cool and fast</strong>!</p>'
    assert_match expected, page.body.strip
  end

  test '.md template handler' do
    visit '/handlers/rdiscount'
    expected = '<p>RDiscount is <em>cool</em> and <strong>fast</strong>!</p>'
    assert_match expected, page.body
  end

  test '.string template handler' do
    visit '/handlers/show'
    expected = 'Congratulations! You just created another template handler!'
    assert_match expected, page.body
  end

  test '.rb template handler' do
    visit '/handlers/index'
    expected = 'This is my first <b>template handler</b>!'
    assert_match expected, page.body
  end
end