#---
# Excerpted from "Crafting Rails Applications",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material,
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose.
# Visit http://www.pragmaticprogrammer.com/titles/jvrails for more book information.
#---
class ActionController::Metal < AbstractController::Base
  # Creates a Rack application on the fly that
  # dispatches the given action name.
  def self.action(name, klass = ActionDispatch::Request)
    middleware_stack.build(name.to_s) do |env|
      new.dispatch(name, klass.new(env))
    end
  end

  # Dispatches the given action name by processing it
  # and returning a valid Rack response.
  def dispatch(name, request)
    @_request = request
    @_env = request.env
    @_env['action_controller.instance'] = self
    process(name)
    to_a
  end

  def to_a
    [status, headers, response_body]
  end
end