#---
# Excerpted from "Crafting Rails Applications",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material,
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose.
# Visit http://www.pragmaticprogrammer.com/titles/jvrails for more book information.
#---
module ActiveRecord
  class Railtie < Rails::Railtie
    config.active_record = ActiveSupport::OrderedOptions.new
    config.app_generators.orm :active_record, :migration => true,
                                              :timestamps => true
    config.app_middleware.insert_after "::ActionDispatch::Callbacks",
      "ActiveRecord::QueryCache"
    rake_tasks do
      load "active_record/railties/databases.rake"
    end

    initializer "active_record.initialize_timezone" do
      ActiveRecord.time_zone_aware_attributes = true
      ActiveRecord.default_timezone = :utc
    end
    initializer "active_record.set_configs" do |app|
      app.config.active_record.each do |k,v|
        ActiveRecord::Base.send("#{k}=", v)
      end
    end
  end
end