#---
# Excerpted from "Crafting Rails Applications",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material,
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose.
# Visit http://www.pragmaticprogrammer.com/titles/jvrails for more book information.
#---
module SqlMetrics
  mattr_accessor :mute_regexp
  @@mute_regexp = nil

  class MuteMiddleware
    def initialize(app)
      @app = app
    end

    def call(env)
      if SqlMetrics.mute_regexp && env["PATH_INFO"] =~ SqlMetrics.mute_regexp
        SqlMetrics.mute!{ @app.call(env) }
      else
        @app.call(env)
      end
    end
  end
end

module SqlMetrics
  def self.mute!
    Thread.current["sql_metrics.mute"] = true
    yield
  ensure
    Thread.current["sql_metrics.mute"] = false
  end

  def self.mute?
    Thread.current["sql_metrics.mute"] || false
  end
end
