#---
# Excerpted from "Crafting Rails Applications",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material,
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose.
# Visit http://www.pragmaticprogrammer.com/titles/jvrails for more book information.
#---
require "active_support/notifications"
require "mongo_mapper"
require "sql_metrics/mute_middleware"
require "sql_metrics/engine"
require "thread"
# We are required to choose a database name
MongoMapper.database = "sql_metrics-#{Rails.env}"
module SqlMetrics
  def self.queue
    @queue ||= Queue.new
  end
  def self.thread
    @thread ||= Thread.new do
      while args = queue.pop
        SqlMetrics::Metric.store!(args)
      end
    end
  end
end   
# Start the Queue and Thread
SqlMetrics.queue
SqlMetrics.thread
ActiveSupport::Notifications.subscribe /^sql\./ do |*args|
  SqlMetrics.queue << args unless SqlMetrics.mute?
end
module SqlMetrics
  def self.finish!
    queue << nil
    thread.join
    @thread = nil
    thread
  end
end