#---
# Excerpted from "Crafting Rails Applications",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material,
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose.
# Visit http://www.pragmaticprogrammer.com/titles/jvrails for more book information.
#---
require 'test_helper'

class NavigationTest < ActiveSupport::IntegrationCase
  test 'can ignore notifications for a given path' do
    assert_difference "SqlMetrics::Metric.count" do
      visit "/users"
      SqlMetrics.finish!
    end

    begin
      SqlMetrics.mute_regexp = %r{^/users}

      assert_no_difference "SqlMetrics::Metric.count" do
        visit "/users"
      end
    ensure
      SqlMetrics.mute_regexp = nil
    end
  end

  test 'can visualize and destroy notifications created in a request' do
    visit new_user_path
    fill_in "Name", :with => "John Doe"
    fill_in "Age", :with => "23"
    click_button "Create User"
    SqlMetrics.finish!

    # Check for the metric data on the page
    visit sql_metrics_path
    assert_match "User Load", page.body
    assert_match "INSERT INTO", page.body
    assert_match "John Doe", page.body
    assert_match "sql.active_record", page.body

    # Assert the number of rows change when an item is destroyed
    assert_difference "all('table tr').count", -1 do
      click_link "Destroy"
    end
  end
end